﻿Imports Infragistics.UltraChart.Resources.Appearance
Imports Infragistics.UltraChart.Shared.Styles
Imports Infragistics.UltraChart.Data.Series
Imports Infragistics.UltraChart.Core.Layers

Public Class Chart
#Region "Propertys"

    Dim myLegend As New CompositeLegend()
    Dim myChartArea As New ChartArea()
    'Dim axisY As New AxisItem()

    Dim dsGrafiek As DataSet = Nothing
    Dim dsGrafiekDetail As DataSet = Nothing
    Dim _datatable As DataTable

    Private Property _Streefwaarde As Integer
    Private Property _ID As String
    Private Property _TypeGrafiek As String ' Type off Chart
    Private Property _Marker As String  'Type off marker
    Private Property _Yas As String 'Second or First Y-axes
    Private Property _Kleur As System.Drawing.Color 'Color
    Private Property _color As System.Drawing.Color

#End Region
    
    Private Sub Chart_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        FillDataset()
        CreateChart1()
    End Sub


    Sub CreateChart1()

        Me.UltraChart1.ChartType = ChartType.Composite
        myChartArea = Me.UltraChart1.CompositeChart.ChartAreas(0)
        Me.UltraChart1.CompositeChart.ChartAreas.Add(myChartArea)

        Dim myLegend As New CompositeLegend()
        Dim myScatterLayer As New ChartLayerAppearance()
        Dim myColumnLayer As New ChartLayerAppearance()

        Try
            'Column chart  Axes
            '***************************************************************************
            Dim axisX As New AxisItem()
            axisX.OrientationType = AxisNumber.X_Axis
            axisX.DataType = AxisDataType.String
            axisX.SetLabelAxisType = SetLabelAxisType.GroupBySeries
            axisX.Labels.ItemFormatString = ""
            axisX.Labels.Orientation = TextOrientation.VerticalLeftFacing

            Dim axisY1 As New AxisItem()
            axisY1.OrientationType = AxisNumber.Y_Axis
            axisY1.DataType = AxisDataType.Numeric
            axisY1.Labels.ItemFormatString = "<DATA_VALUE:0.#>"
            axisY1.RangeMax = 100000000



            Dim axisY As New AxisItem()
            axisY.OrientationType = AxisNumber.Y_Axis
            axisY.DataType = AxisDataType.Numeric
            axisY.Labels.ItemFormatString = "<DATA_VALUE:0.#>"
            axisY.RangeMax = 100000000


            'Line chart  Axes
            '***************************************************************************
            Dim axisX2 As New AxisItem()
            axisX2.OrientationType = AxisNumber.X2_Axis
            axisX2.DataType = AxisDataType.Numeric
            axisX2.Labels.ItemFormatString = ""
            axisX2.Labels.Orientation = TextOrientation.VerticalLeftFacing
            axisX2.Extent = 40


            Dim axisY2 As New AxisItem()
            axisY2.OrientationType = AxisNumber.Y2_Axis
            axisY2.DataType = AxisDataType.Numeric
            axisY2.Labels.ItemFormatString = "<DATA_VALUE:0.#>"
            axisY2.Labels.Orientation = TextOrientation.Horizontal
            axisY2.Extent = 150

            myChartArea.Axes.Add(axisX2)
            myChartArea.Axes.Add(axisY)
            myChartArea.Axes.Add(axisY1)
            myChartArea.Axes.Add(axisY2)


            For i As Integer = 1 To dsGrafiek.Tables(0).Columns.Count - 2
                FillDetail(dsGrafiek.Tables(0).Columns(i).ColumnName.ToString)
                Select Case _TypeGrafiek
                    Case "Line"
                        Dim _Series As XYSeries = AddLineChart(dsGrafiek.Tables(0).Columns(i).ColumnName.ToString)
                        Me.UltraChart1.CompositeChart.Series.Add(_Series)
                        _Series.PEs.Add(New PaintElement(_color))
                        If Not IsNothing(myScatterLayer) Then
                            myScatterLayer = New ChartLayerAppearance()
                        End If

                        myScatterLayer.ChartType = ChartType.ScatterChart

                        CType(myScatterLayer.ChartTypeAppearance, ScatterChartAppearance).ConnectWithLines = True
                        myScatterLayer.ChartArea = myChartArea

                        myScatterLayer.AxisX = axisX2
                        myScatterLayer.AxisY = axisY

                        myScatterLayer.Series.Add(_Series)
                        Me.UltraChart1.CompositeChart.ChartLayers.Add(myScatterLayer)

                        ' Add the first layer to the legend.
                        myLegend.Bounds = New Rectangle(10, 10, 20, 25)
                        myLegend.BoundsMeasureType = MeasureType.Percentage
                        myLegend.PE.ElementType = PaintElementType.Gradient
                        myLegend.PE.FillGradientStyle = GradientStyle.ForwardDiagonal
                        myLegend.PE.Fill = Drawing.Color.CornflowerBlue
                        myLegend.PE.FillStopColor = Drawing.Color.Transparent
                        myLegend.Border.CornerRadius = 10
                        myLegend.Border.Thickness = 0
                        myLegend.ChartLayers.Add(myScatterLayer)
                    Case "Staaf"
                        Dim _Series As XYSeries = AddLineChart(dsGrafiek.Tables(0).Columns(i).ColumnName.ToString)
                        Me.UltraChart1.CompositeChart.Series.Add(_Series)
                        _Series.PEs.Add(New PaintElement(_color))

                        If Not IsNothing(myColumnLayer) Then
                            myColumnLayer = New ChartLayerAppearance()
                        End If
                        myColumnLayer.ChartType = ChartType.ColumnChart

                        myColumnLayer.ChartArea = myChartArea

                        myColumnLayer.AxisX = axisX
                        myColumnLayer.AxisY = axisY1

                        myColumnLayer.Series.Add(_Series)
                        myColumnLayer.SwapRowsAndColumns = True
                        Me.UltraChart1.CompositeChart.ChartLayers.Add(myColumnLayer)

                        ' Add the second layer to the legend.
                        myLegend.ChartLayers.Add(myColumnLayer)
                        myLegend.Bounds = New Rectangle(10, 10, 20, 25)
                        myLegend.BoundsMeasureType = MeasureType.Percentage
                        myLegend.PE.ElementType = PaintElementType.Gradient
                        myLegend.PE.FillGradientStyle = GradientStyle.ForwardDiagonal
                        myLegend.PE.Fill = Drawing.Color.CornflowerBlue
                        myLegend.PE.FillStopColor = Drawing.Color.Transparent
                        myLegend.Border.CornerRadius = 10
                        myLegend.Border.Thickness = 0
                End Select
            Next
            'Legend 
            '***************************************************************************
            Me.UltraChart1.CompositeChart.Legends.Add(myLegend)

        Catch ex As Exception
            MessageBox.Show(ex.ToString)
        End Try
    End Sub
    Private Sub FillDetail(aID As String)
        _ID = String.Empty
        _TypeGrafiek = String.Empty
        _Marker = String.Empty
        _Kleur = Nothing
        _Yas = String.Empty

        Dim dvLocaal As DataView
        dvLocaal = New DataView(dsGrafiekDetail.Tables(0))

        If Microsoft.VisualBasic.Left(aID, 2) = "V " Then 'Het gaat hier om een voortschrijdende gemiddelde
            'Filter voorwaarden = Voortglijdende gemiddelde = True
            '                               ID_TKN_MET
            '                               ID_GG_INV
            With dvLocaal
                .RowFilter = "IsVoortschrijdendeGemiddelde = 1 and ID_TKN_MET = '" & Mid(Trim(aID), 3, 5) & "' and ID_GG_INV = '" & _
                    Microsoft.VisualBasic.Right(Trim(aID), 2) & ""
            End With
            If dvLocaal.Count = 1 Then
                _ID = aID
                _TypeGrafiek = dvLocaal.Item(0).Row("TypeGrafiek")
                _Marker = dvLocaal.Item(0).Row("StructuurGrafiek")
                _Kleur = Color(dvLocaal.Item(0).Row("Kleur").ToString)
                _Yas = dvLocaal.Item(0).Row("TweedeAs")
            End If

        ElseIf aID.ToString.Length > 8 Then 'Het gaat hier om een expressie
            'Filter voorwaarden = Expressie = dsGrafiek.Tables(0).Columns(colindex).ColumnName.ToString.Length
            With dvLocaal
                .RowFilter = "Expressie = dsGrafiek.Tables(0).Columns(colindex).ColumnName.ToString"
            End With
            If dvLocaal.Count = 1 Then
                _ID = aID.ToString
                _TypeGrafiek = dvLocaal.Item(0).Row("TypeGrafiek")
                _Marker = dvLocaal.Item(0).Row("StructuurGrafiek")
                _Kleur = Color(dvLocaal.Item(0).Row("Kleur").ToString)
                _Yas = dvLocaal.Item(0).Row("TweedeAs")
            End If

        ElseIf aID.ToString.Equals("Streefwaarde") Then 'Het gaat hier om de streefwaarde
            _Streefwaarde = 0

        Else 'Het gaat hier om een gewone id
            With dvLocaal
                .RowFilter = "ID_TKN_MET = '" & Microsoft.VisualBasic.Left(Trim(aID), 5) & "'  and ID_GG_INV = '" & _
                    Microsoft.VisualBasic.Right(Trim(aID), 2) & "'"
            End With
            If dvLocaal.Count = 1 Then
                _ID = aID
                _TypeGrafiek = dvLocaal.Item(0).Row("TypeGrafiek")
                _Marker = dvLocaal.Item(0).Row("StructuurGrafiek")
                _Kleur = Color(dvLocaal.Item(0).Row("Kleur").ToString)
                _Yas = dvLocaal.Item(0).Row("TweedeAs")
            End If
        End If

    End Sub
    Private Sub FillDataset()
        dsGrafiek = New DataSet
        dsGrafiekDetail = New DataSet

        dsGrafiek.ReadXml("Grafiek.xml")
        dsGrafiekDetail.ReadXml("GrafiekDetail.xml")
      

        Try
            _datatable = New DataTable()
            _datatable = dsGrafiek.Tables(0)
        Catch ex As Exception
            MessageBox.Show(ex.ToString)
        End Try

    End Sub
    Private Function CreerSeriesDataTable(aID As String) As DataTable
        Dim i As Double = 0
        Dim dValue As Double = Nothing
        Dim table As New DataTable()
        table = New DataTable
        table.Columns.Add("Label Column", GetType(String))
        table.Columns.Add("Waarde1", GetType(Double))
        table.Columns.Add("Waarde2", GetType(Double))

        For Each r As DataRow In dsGrafiek.Tables(0).Rows
            If Not IsNumeric(r.Item(aID).ToString) Then
                dValue = Nothing
            Else
                dValue = r.Item(aID).ToString
            End If
            table.Rows.Add(New Object() {r.Item(0).ToString, i, dValue})
            i += 10
        Next

        Return table

    End Function
    Private Function AddLineChart(aID As String) As XYSeries
        'Dim i As Integer = 0
        'Dim dValue As Double = Nothing
        'Dim series As New XYSeries()

        Dim series As New XYSeries()
        series.Label = aID
        ' this code populates the series from an external data source
        Dim table As DataTable = CreerSeriesDataTable(aID)
        series.Data.DataSource = table
        series.Data.LabelColumn = "Label Column"
        series.Data.ValueXColumn = "Waarde1"
        series.Data.ValueYColumn = "Waarde2"
        Return series

     
        Return series
    End Function
    Private Function AddColumnChart(aID As String) As NumericSeries
        Dim series As New NumericSeries()
        series.Label = aID
        Dim table As DataTable = CreerSeriesDataTable(aID)
        series.Data.DataSource = table
        series.Data.LabelColumn = "Label Column"
        series.Data.ValueColumn = "Waarde2"
        Return series
    End Function
 

    Private Function Color(aColor As String) As System.Drawing.Color
        Select Case aColor
            'Color [Yellow]
            Case "Color [DodgerBlue]"
                _color = Drawing.Color.DodgerBlue
            Case "Color [AntiqueWhite]"
                _color = Drawing.Color.AntiqueWhite
            Case "Color [DarkRed]"
                _color = Drawing.Color.DarkRed
            Case "Color [Cyan]"
                _color = Drawing.Color.Cyan
            Case "Color [Yellow]"
                _color = Drawing.Color.Yellow
            Case "Color [Goldenrod]"
                _color = Drawing.Color.Goldenrod
            Case "Color [Magenta]"
                _color = Drawing.Color.Magenta
            Case "Color [LightGreen]"
                _color = Drawing.Color.LightGreen
            Case "Color [HotPink]"
                _color = Drawing.Color.HotPink
            Case "Color [Silver]"
                _color = Drawing.Color.YellowGreen
            Case "Color [Black]"
                _color = Drawing.Color.Silver
            Case "Color [Brown]"
                _color = Drawing.Color.Brown
            Case "Color [Coral]"
                _color = Drawing.Color.Coral
            Case "Color [CadetBlue]"
                _color = Drawing.Color.CadetBlue
            Case "Color [DarkGoldenrod]"
                _color = Drawing.Color.DarkGoldenrod
            Case "Color [DarkKhaki]"
                _color = Drawing.Color.DarkKhaki
            Case "Color [DarkOrange]"
                _color = Drawing.Color.DarkOrange
            Case "Color [DarkTurquoise]"
                _color = Drawing.Color.DarkTurquoise
            Case "Color [DeepPink]"
                _color = Drawing.Color.DeepPink
            Case "Color [DeepSkyBlue]"
                _color = Drawing.Color.DeepSkyBlue
            Case "Color [DarkViolet]"
                _color = Drawing.Color.DarkViolet
            Case Else
                _color = Drawing.Color.YellowGreen
        End Select
    End Function
End Class